#coding: utf-8



'''
拉流压力测试
'''
import threading
import time
import traceback

import cv2


class PullStreamTest():

    def __init__(self):
        self.playUrl = None
        self.isShowFrame = 0                                             # 是否展示预览窗口 0：不展示   1：展示
        self.terNum = 2                                                  # 要压力测试的线程数
        self.threadInfoPull = {}                                         # 存放线程集（拉流线程）
        self.threadInfoPull["threadObj"] = {}
        self.threadInfoPull["sucessT"] = {}
        self.threadInfoPull["failT"] = {}

    def setPlayUrl(self,data):
        self.playUrl = data
    def setTerNum(self,data):
        self.terNum = data


    def getThreadInfoPull(self):
        return self.threadInfoPull

    ############################################
    #           拉流
    ############################################
    def testPull(self,threadName):
        pullUrl = self.playUrl
        cap = cv2.VideoCapture(pullUrl)
        try:
            while (cap.isOpened()):
                ret, frame = cap.read()
                if ret == False:
                    break
                if self.isShowFrame == 1:
                    cv2.imshow("video", frame)
                if cv2.waitKey(1) & 0xFF == ord('q'):
                    break
            print("拉流结束")
            cap.release()
            cv2.destroyAllWindows()
        except:
            traceback.print_exc()
            self.threadInfoPull["threadObj"].pop(threadName)
            return
        self.threadInfoPull["threadObj"].pop(threadName)

    ################################################
    #      启动拉流线程
    ################################################
    def runPull(self, threadId):
        time.sleep(1)
        pullThread = threading.Thread(target=self.testPull, args=(threadId,))
        self.threadInfoPull["threadObj"][threadId] = pullThread
        pullThread.start()

    ################################################
    #      启动压力测试服务
    ################################################
    def start(self):
        for j in range(0, self.terNum):
            threadPullId = "threadPullId__" + str(j)
            print("启动拉流线程：" + threadPullId)
            self.runPull(threadPullId)
            time.sleep(0.01)

if __name__ == "__main__":
    obj = PullStreamTest()
    obj.setPlayUrl("http://10.100.11.125:8085/live?port=1985&app=vandyo&stream=110000000000-1-336024758078409597")
    obj.setTerNum(10)
    obj.start()




